#include "FFNN.h"

//֐ŝ܂ܓKp֐
void FFNN::activationFunction(Matrix& m, Matrix& out, bool last) {
	for (int i = 0; i < m.N; i++) {
		for (int j = 0; j < m.M; j++) {
			if (last == true) out[i][j] = activationFunction_output(m[i][j]);
			else out[i][j] = activationFunction(m[i][j]);
		}
	}
}

//͑w̃jbglݒ肷֐
void FFNN::setInput(double *_input) {
	for (int i = 0; i < structure[0]; i++) {
		input[i] = _input[i];
	}
};

//j[lbg[N̏vZs֐iinput->outputj
void FFNN::calculateFeedForward() {
	//͒l̍XV
	for (int i = 0; i < structure[0]; i++) {
		Z[0][i][0] = input[i];
	}
	for (int n = 0; n < layerN - 1; n++) {
		//z[n + 1] = W[n] * X[n] + B[n];
		Matrix::multiplyMatries(W[n], Z[n], z[n + 1]).add(B[n]);

		bool last = (n == layerN - 2) ? true : false;
		activationFunction(z[n + 1], Z[n + 1], last);
	}
	//o͒l̍XV
	getOutput(output);
};

//덷t`@̃f^lƌžvZ֐
void FFNN::calculateBackPropagation() {

	//ŏIw̃lݒ
	setDeltaN();
	for (int i = 0; i < structure[layerN-1]; i++) {
		delta[layerN-1][i][0] = deltaN[i];
	}

	//wԍ
	for (int n = layerN - 2; n > 0; n--) {

		for (int i = 0; i < structure[n]; i++) {

			delta[n].set(i, 0, 0);

			for (int j = 0; j < structure[n + 1]; j++) {

				if (n == layerN - 2) {
					//ŏIw
					delta[n][i][0] += delta[n + 1][j][0] * W[n][j][i] * activationFunction_output_derivative(z[n + 1][j][0]);

				}
				else {
					//ȊO
					delta[n][i][0] += delta[n + 1][j][0] * W[n][j][i] * activationFunction_derivative(z[n + 1][j][0]);
				}

			}

		}
	}

	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {

				if (n == layerN - 2) {
					//ŏIw
					dLdW[n][i][j] = delta[n + 1][i][0] * Z[n][j][0] * activationFunction_output_derivative(z[n + 1][i][0]);
				}
				else {
					dLdW[n][i][j] = delta[n + 1][i][0] * Z[n][j][0] * activationFunction_derivative(z[n + 1][i][0]);
				}

			}
		}
	}
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			if (n == layerN - 2) {
				//ŏIw
				dLdB[n][i][0] = delta[n + 1][i][0] * activationFunction_output_derivative(z[n + 1][i][0]);
			}
			else {
				dLdB[n][i][0] = delta[n + 1][i][0] * activationFunction_derivative(z[n + 1][i][0]);
			}
		}
	}

	add_dLdB(1.0 / double(batch_size));
	add_dLdW(1.0 / double(batch_size));

}

//dݒlXV֐
void FFNN::updateW() {
	update_dLdW();
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {
				double temp_DeltaW = DeltaW[n][i][j];

				if (typeOfLearning == 0) {
					DeltaW[n][i][j] = -eta * dLdW[n][i][j];
				}
				else if (typeOfLearning == 1) {
					//[^@
					DeltaW[n][i][j] = mu * DeltaW_old[n][i][j] - (1.0 - mu)* eta * dLdW[n][i][j];
				}
				else if (typeOfLearning == 2) {
					//AdaGrad

					double epsilon = (Wv[n][i][j] < 1.0) ? 1.0 : 0;
					DeltaW[n][i][j] = mu * DeltaW_old[n][i][j] - (1.0 - mu)* eta / sqrt(Wv[n][i][j] + epsilon) * dLdW[n][i][j];
					Wv[n][i][j] += dLdW[n][i][j] * dLdW[n][i][j];

				}
				else if (typeOfLearning == 3) {
					//RMSprop
					double temp_Wv = Wv[n][i][j];
					Wv[n][i][j] = rho * Wv_old[n][i][j] + (1.0 - rho) * dLdW[n][i][j] * dLdW[n][i][j];

					double epsilon = (Wv[n][i][j] < 1.0) ? 1.0 : 0;
					DeltaW[n][i][j] = mu * DeltaW_old[n][i][j] - (1.0 - mu)* eta / sqrt(Wv[n][i][j] + epsilon) * dLdW[n][i][j];

					Wv_old[n][i][j] = temp_Wv;
				}

				W[n][i][j] = W[n][i][j] + DeltaW[n][i][j];
				DeltaW_old[n][i][j] = temp_DeltaW;

			}
		}
	}
	reset_dLdW();
}
//oCAXlXV֐
void FFNN::updateB() {

	update_dLdB();
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			double temp_DeltaB = DeltaB_old[n][i][0];


			if (typeOfLearning == 0) {
				DeltaB[n][i][0] = -eta * dLdB[n][i][0];
			}
			else if (typeOfLearning == 1) {
				//[^@
				DeltaB[n][i][0] = mu * DeltaB_old[n][i][0] - (1.0 - mu)* eta * dLdB[n][i][0];
			}
			else if (typeOfLearning == 2) {

				//AdaGrad
				double epsilon = (Bv[n][i][0] < 1.0) ? 1.0 : 0;
				DeltaB[n][i][0] = mu * DeltaB_old[n][i][0] - (1.0 - mu)*eta / sqrt(Bv[n][i][0] + epsilon) * dLdB[n][i][0];
				Bv[n][i][0] += dLdB[n][i][0] * dLdB[n][i][0];
			}
			else if (typeOfLearning == 3) {

				double temp_Bv = Bv[n][i][0];
				//RMSprop
				Bv[n][i][0] = rho * Bv_old[n][i][0] + (1.0 - rho) * dLdB[n][i][0] * dLdB[n][i][0];

				double epsilon = (Bv[n][i][0] < 1.0) ? 1.0 : 0;
				DeltaB[n][i][0] = mu * DeltaB_old[n][i][0] - (1.0 - mu)* eta / sqrt(Bv[n][i][0] + epsilon) * dLdB[n][i][0];

				Bv_old[n][i][0] = temp_Bv;


			}

			B[n][i][0] = B[n][i][0] + DeltaB[n][i][0];
			DeltaB_old[n][i][0] = temp_DeltaB;

		}
	}
	reset_dLdB();
}

//o͑w̃j[l̎擾֐
void FFNN::getOutput(double* _output) {
	for (int i = 0; i < structure[layerN-1]; i++) {
		_output[i] = Z[layerN-1][i][0];
	}
};

//dLdW_dLdWZbg֐
void FFNN::reset_dLdW() {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {
				dLdW[n][i][j] = 0;
				_dLdW[n][i][j] = 0;
			}
		}
	}
}
//dLdW̕ςvZ邽߂̘avZ֐
void FFNN::add_dLdW(double factor = 1.0) {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {
				_dLdW[n][i][j] += dLdW[n][i][j] * factor;
			}
		}
	}
}
//dLdW𕽋ϒlɒu֐
void FFNN::update_dLdW() {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {
				dLdW[n][i][j] = _dLdW[n][i][j];
			}
		}
	}
}

//dLdB_dLdBZbg֐
void FFNN::reset_dLdB() {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			dLdB[n][i][0] = 0;
			_dLdB[n][i][0] = 0;
		}
	}
}
//dLdB̕ςvZ邽߂̘avZ֐
void FFNN::add_dLdB(double factor = 1.0) {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			_dLdB[n][i][0] += dLdB[n][i][0] * factor;
		}
	}
}
//dLdB𕽋ϒlɒu֐
void FFNN::update_dLdB() {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			dLdB[n][i][0] = _dLdB[n][i][0];
		}
	}
}

//dݒlݒ肷֐
void FFNN::setW(Matrix* _W) {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {
				W[n][i][j] = _W[n][i][j];
			}
		}
	}
}
//oCAXlݒ肷֐
void FFNN::setB(Matrix* _B) {
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			B[n][i][0] = _B[n][i][0];
		}
	}
}

//d݂ƃoCAX̏l萔{֐
void FFNN::adoptFactor(double _weightFactor, double _biasFactor) {
	weightFactor = _weightFactor;
	biasFactor = _biasFactor;

	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			for (int j = 0; j < structure[n]; j++) {
				W[n][i][j] *= weightFactor;
			}
		}
	}
	for (int n = 0; n < layerN-1; n++) {
		for (int i = 0; i < structure[n + 1]; i++) {
			B[n][i][0] *= biasFactor;
		}
	}
}


//lbg[N̊wKs֐
void FFNN::learnNetwork() {
	//ZkEcCX^̏
	//mt.seed(rnd());
	unsigned int seed = (unsigned)time(NULL) + clock();
#ifdef _OPENMP 
	seed += omp_get_thread_num();
#endif 

	mt.seed(seed);
	//G|bN
	for (int epoch = 1; epoch <= iterations; epoch++) {
		//ob`wK
		for (int batch = 1; batch <= batch_size; batch++) {

			//`input^i[U[`j
			defineInput();

			//vZ̎s
			learnNetworkOnce();

			//ob`wK㏈̎si[U[`j
			after_batch(epoch, batch);
		}

		//WBob`wKœꂽϒlɍXV
		updateW();
		updateB();

		//G|bNI㏈̎si[U[`j
		after_epoch(epoch);
	}

	//wKI㏈̎si[U[`j
	after_learning();

}

//wKlbg[Npj[lbg[NvZs֐
void FFNN::calculateNeuralNetwork(double* _input, double* _output) {
	//͒l̐ݒ
	setInput(_input);

	//j[lbg[N̏vZiPj
	calculateFeedForward();

	//o͂̏
	for (int i = 0; i < structure[layerN-1]; i++) {
		_output[i] = output[i];
	}

}

//wKpf[^ݒ肷֐
void FFNN::setLearningData(double* _input, double* _teacherSignalOutput) {

	for (int i = 0; i < structure[0]; i++) {
		input[i] = _input[i];
	}

	for (int i = 0; i < structure[layerN-1]; i++) {
		teacherSignalOutput[i] = _teacherSignalOutput[i];
	}

}
//lbg[N̊wKs֐
void FFNN::learnNetworkOnce() {

	//vZ̎s
	calculateFeedForward();

	//덷t`vZ̎s
	calculateBackPropagation();

}
//lbg[N̊wKs֐
void FFNN::learnNetworkOnce(double* _input, double* _teacherSignalOutput) {

	setLearningData(_input, _teacherSignalOutput);

	learnNetworkOnce();

}
//////////////////////////////////////////////////
// FFNNNX@[U[`p֐
//////////////////////////////////////////////////

//֐
double FFNN::lossFunction() {
	double sum = 0;
	for (int i = 0; i < structure[layerN-1]; i++) {
		sum += (output[i] - teacherSignalOutput[i])*(output[i] - teacherSignalOutput[i]) / 2.0;
	}
	//LASSOAqɂyieB
	if (lambda > 0) {
		for (int n = 0; n < layerN-1; n++) {
			for (int i = 0; i < structure[n + 1]; i++) {
				for (int j = 0; j < structure[n]; j++) {
					sum += lambda * abs(W[n][i][j]);
				}
			}
		}
	}
	return sum;
}


//֐iԑwpj
double FFNN::activationFunction(double x) {
	if (x >= 0) return x;
	return 0;
}
//֐iԑwpj̔
double FFNN::activationFunction_derivative(double x) {
	if (x >= 0) return 1;
	return 0;

}
//֐io͑wpj
double FFNN::activationFunction_output(double x) {
	return x;
}
//֐io͑wpj
double FFNN::activationFunction_output_derivative(double x) {
	return 1;
}
//ŏIw̃f^l^֐iŏIw֐Ɉˑj
void FFNN::setDeltaN() {
	//ŏIw̃lvZ
	for (int i = 0; i < structure[layerN-1]; i++) {
		deltaN[i] = (output[i] - teacherSignalOutput[i]);
	}
}

//ob`eŌɌĂяo֐
void FFNN::after_batch(int epoch, int batch) {}
//G|bNeŌɌĂяo֐
void FFNN::after_epoch(int epoch) {}
//wKIiSG|bNIjɌĂяo֐
void FFNN::after_learning() {}