#ifndef __FFNN_H__INCLUDED
#define __FFNN_H__INCLUDED

#include <math.h>
#include <iostream>
#include <random>
#include <time.h>
#include <omp.h>

#include "Matrix.h"

class FFNN {
private:
	bool initFlag = false;
public:
	//w
	int layerN;
	//lbg[N̍\
	int* structure;

	//́Eo
	double* input;
	double* output;
	double* teacherSignalOutput;


	//ŏIw̃f^l
	double* deltaN;

	//wK
	int iterations = 1000;
	//~job`̃TCY
	int batch_size = 1;

	//dݍs[wԍ][o͔ԍ][͔ԍ]
	Matrix *W;
	//jbgl
	Matrix *Z;
	//oCAX
	Matrix *B;

	double lastLossValue;

	//֐ʂÕjbgl
	Matrix *z;
	//덷t`@̃f^l
	Matrix *delta;

	//wK
	double eta = 0.1;
	//wK@̎
	int typeOfLearning = 0;
	//wKp[^
	double mu = 0.70;
	double rho = 0.5;

	//LASSOAq
	double lambda = 0;

	//dݏq
	double weightFactor = 1.0;
	//oCAXq
	double biasFactor = 1.0;

	//Δli[鑽dz
	Matrix *dLdW; //[wԍ][j[ԍ]
	Matrix *dLdB; //[wԍ][j[ԍ]

				  //dLdWdLdB̕ϒlvZpϐ
	Matrix *_dLdW;
	Matrix *_dLdB;

	//WB̊wKP񕪂̕ω
	Matrix *DeltaW;
	Matrix *DeltaB;

	//PODeltaWDeltaB
	Matrix *DeltaW_old;
	Matrix *DeltaB_old;


	//WvBv
	Matrix *Wv;
	Matrix *Bv;
	Matrix *Wv_old;
	Matrix *Bv_old;

	std::random_device rnd; //񌈒Iȗ
	std::mt19937 mt;        //32rbgŃZkEcCX^
	std::uniform_real_distribution<> rand_real_0_1;
	FFNN() {}
	FFNN(int _layerN, int* _structure) {
		init(_layerN, _structure);
	}
	virtual ~FFNN() {
		if (initFlag) {
			delete[] structure;
			delete[] W;
			delete[] dLdW;
			delete[] DeltaW;
			delete[] DeltaW_old;
			delete[] _dLdW;
			delete[] Wv;
			delete[] Wv_old;
			delete[] Z;
			delete[] z;
			delete[] delta;
			delete[] B;
			delete[] dLdB;
			delete[] DeltaB;
			delete[] DeltaB_old;
			delete[] _dLdB;
			delete[] Bv;
			delete[] Bv_old;
			delete[] output;
			delete[] input;
			delete[] deltaN;
		}
	}
	void init(int _layerN, int* _structure) {
		layerN = _layerN;
		structure = new int[layerN];
		for (int n = 0; n < layerN; n++) {
			structure[n] = _structure[n];
		}
		init();
	}

	void init() {
		W = new Matrix[layerN-1];
		dLdW = new Matrix[layerN-1];
		_dLdW = new Matrix[layerN-1];
		DeltaW = new Matrix[layerN-1];
		DeltaW_old = new Matrix[layerN-1];
		Wv = new Matrix[layerN-1];
		Wv_old = new Matrix[layerN-1];

		Z = new Matrix[layerN];
		z = new Matrix[layerN];
		delta = new Matrix[layerN];
		B = new Matrix[layerN-1];
		dLdB = new Matrix[layerN-1];
		_dLdB = new Matrix[layerN-1];
		DeltaB = new Matrix[layerN-1];
		DeltaB_old = new Matrix[layerN-1];
		Bv = new Matrix[layerN-1];
		Bv_old = new Matrix[layerN-1];

		for (int n = 0; n < layerN; n++) {
			Z[n] = Matrix(structure[n], 1); //icxNgj
			z[n] = Matrix(structure[n], 1); //icxNgj
			delta[n] = Matrix(structure[n], 1); //icxNgj

		}
		for (int n = 0; n < layerN-1; n++) {
			W[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			dLdW[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			_dLdW[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			DeltaW[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			DeltaW_old[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			Wv[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			Wv_old[n] = Matrix(structure[n + 1], structure[n]);//dݒl[wԍ] = Matrix[o͔ԍ][͔ԍ]
			B[n] = Matrix(structure[n + 1], 1); //icxNgj
			dLdB[n] = Matrix(structure[n + 1], 1); //icxNgj
			_dLdB[n] = Matrix(structure[n + 1], 1); //icxNgj
			DeltaB[n] = Matrix(structure[n + 1], 1); //icxNgj
			DeltaB_old[n] = Matrix(structure[n + 1], 1); //icxNgj
			Bv[n] = Matrix(structure[n + 1], 1); //icxNgj
			Bv_old[n] = Matrix(structure[n + 1], 1); //icxNgj
		}
		std::uniform_real_distribution<> rand_real_0_1(0, 1.0);
		//urand_real_0_1(mt)vPsłP̗𐶐

		//dݍs̐ݒ
		for (int n = 0; n < layerN-1; n++) {
			for (int i = 0; i < structure[n + 1]; i++) {
				for (int j = 0; j < structure[n]; j++) {
					W[n][i][j] = 2.0*(rand_real_0_1(mt) - 0.5) * sqrt(6.0 / double(structure[n]));
					dLdW[n][i][j] = 0;
					_dLdW[n][i][j] = 0;
					DeltaW[n][i][j] = 0;
					DeltaW_old[n][i][j] = 0;
					Wv[n][i][j] = 0;
					Wv_old[n][i][j] = 0;
				}
			}
		}
		//oCAXl̐ݒiŏIw͂Oj
		for (int n = 0; n < layerN-1; n++) {
			for (int i = 0; i < structure[n + 1]; i++) {
				B[n][i][0] = (n != layerN - 2) ? 2.0*(rand_real_0_1(mt) - 0.5) * sqrt(6.0 / double(structure[n])) : 0;
				dLdB[n][i][0] = 0;
				_dLdB[n][i][0] = 0;
				DeltaB[n][i][0] = 0;
				DeltaB_old[n][i][0] = 0;
				Bv[n][i][0] = 0;
				Bv_old[n][i][0] = 0;
			}
		}
		input = new double[structure[0]];
		output = new double[structure[layerN-1]];
		teacherSignalOutput = new double[structure[layerN-1]];
		deltaN = new double[structure[layerN-1]];
		initFlag = true;
	}


	//֐ŝ܂ܓKp֐
	void activationFunction(Matrix& m, Matrix& out, bool last);

	//͑w̃jbglݒ肷֐
	void setInput(double *_input);
	void setLearningData(double* _input, double* _teacherSignalOutput);

	//j[lbg[N̏vZs֐iinput->outputj
	void calculateFeedForward();

	//덷t`@̃f^lƌžvZ֐
	void calculateBackPropagation();

	//dݒlXV֐
	void updateW();

	//oCAXlXV֐
	void updateB();

	//o͑w̃j[l̎擾֐
	void getOutput(double* _output);

	//dLdW_dLdWZbg֐
	void reset_dLdW();

	//dLdW̕ςvZ邽߂̘avZ֐
	void add_dLdW(double factor);

	//dLdW𕽋ϒlɒu֐
	void update_dLdW();

	//dLdB_dLdBZbg֐
	void reset_dLdB();

	//dLdB̕ςvZ邽߂̘avZ֐
	void add_dLdB(double factor);

	//dLdB𕽋ϒlɒu֐
	void update_dLdB();

	//dݒlݒ肷֐
	void setW(Matrix* _W);

	//oCAXlݒ肷֐
	void setB(Matrix* _B);

	//lbg[N̊wKs֐
	void learnNetwork();
	void learnNetworkOnce();
	void learnNetworkOnce(double* _input, double* _teacherSignalOutput);

	//wKlbg[Npj[lbg[NvZs֐
	void calculateNeuralNetwork(double* _input, double* _output);

	//d݂ƃoCAX̏l萔{֐
	void adoptFactor(double _weightFactor, double _biasFactor);

	/////////////////////////////////////////////////////////
	//ȉA[U[`pvg^Cv錾
	/////////////////////////////////////////////////////////
	//wKpinputf[^@w肷֐
	virtual void defineInput();
	//ŏIw̃f^l^֐iŏIw֐Ɉˑj
	virtual void setDeltaN();
	//֐
	virtual double lossFunction();

	//ݒ肵͂ɑ΂鑹l̕ςvZ֐
	virtual double getMeanLossValue();
	//tM^֐
	static void calculateTeacherSignal(double* input, double* output);
	static void calculateTeacherSignal_inverse(double* output, double* input);
	//֐iԑwpj
	virtual double activationFunction(double x);
	//֐iԑwpj̔
	virtual double activationFunction_derivative(double x);
	//֐io͑wpj
	virtual double activationFunction_output(double x);
	//֐io͑wpj̔
	virtual double activationFunction_output_derivative(double x);
	//ob`eŌɌĂяo֐
	virtual void after_batch(int epoch, int batch);
	//G|bNeŌɌĂяo֐
	virtual void after_epoch(int epoch);
	//wKIiSG|bNIjɌĂяo֐
	virtual void after_learning();

};

#endif //__FFNN_H__INCLUDED
