#ifndef __Matrix_H__INCLUDED
#define __Matrix_H__INCLUDED

#include <math.h>
#include <iostream>

class Matrix {
private:
public:
	double **elements;
	int N; //s
	int M; //
	Matrix(int _N = 1, int _M = 1) {
		N = _N;
		M = _M;
		elements = new double*[N];
		for (int i = 0; i<N; i++) {
			elements[i] = new double[M];
			for (int j = 0; j < M; j++) {
				elements[i][j] = 0;
			}
		}
	}
	Matrix(const Matrix& m) {
		N = m.N;
		M = m.M;
		elements = new double*[N];
		for (int i = 0; i<N; i++) {
			elements[i] = new double[M];
			for (int j = 0; j < M; j++) {
				elements[i][j] = m.elements[i][j];
			}
		}
	}

	~Matrix() {
		// IɊmۂ̈
		for (int i = 0; i<N; i++) delete[] elements[i];
		delete[] elements;
	}

	void resetSize(int, int);
	void set(int i, int j, double value);
	double get(int i, int j);
	void copy(const Matrix& m);
	Matrix& multiply(const Matrix& m);
	Matrix& add(const Matrix& m);

	Matrix clone();
	//I[o[[hu=v
	Matrix& operator = (const Matrix& m);
	friend  Matrix operator * (const Matrix& m1, const Matrix& m2);
	friend  Matrix operator - (const Matrix& m1, const Matrix& m2);
	friend  Matrix operator + (const Matrix& m1, const Matrix& m2);
	double* operator[](int i);
	double operator()(int i, int j);

	static Matrix transpose( Matrix& m );
	static Matrix& multiplyMatries(Matrix& m1, Matrix& m2, Matrix& out);

	static void readMatrix(Matrix& m) {
		for (int i = 0; i<m.N; i++) {
			for (int j = 0; j < m.M; j++) {
				std::cout << m[i][j] << " ";
			}
			std::cout << std::endl;
		}
	}

};




#endif //__Matrix_H__INCLUDED
